<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of actions
 *
 * @author Manuel Enrique Paredes Lopez
 * @email->mparedes@sofhouse.net
 */
class co_contrato_sireci_sgrActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CONTRATO_SIRECI_SGR'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CONTRATO_SIRECI_SGR' =>
        array(
            'id_contrato_sireci_sgr' => 'id_contrato_sireci_sgr',
            'id_contrato' => 'id_contrato',
            'no_contrato' => 'no_contrato',
            'justificacion' => 'justificacion',
            'clase_contrato' => 'clase_contrato',
            'otra_clase_contrato' => 'otra_clase_contrato',
            'pago_anticipado' => 'pago_anticipado',
            'valor_pago_anticipado' => 'valor_pago_anticipado',
            'ejecucion_fis_contrato' => 'ejecucion_fis_contrato',
            'observaciones' => 'observaciones',
            'just'          => 'just',
            'otra_fuente'   => 'otra_fuente',
            'otra_fuente_finan' => 'otra_fuente_finan'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CONTRATO_SIRECI_SGR' =>
        array(
            'id_contrato_sireci_sgr,a' => array('!=' => array(-1)),
            'id_contrato_sireci_sgr,b' => array('=' => array('id_contrato_sireci_sgr')),
            'id_contrato' => array('=' => array('id_contrato')),
            'no_contrato' => array('=' => array('no_contrato')),
            'clase_contrato' => array('=' => array('clase_contrato')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contrato_sireci_sgr'; //identificador de la tabla
    protected $id_names = array('id_contrato_sireci_sgr'); //llave primaria
    protected $field_names = array('id_contrato', 'no_contrato', 'justificacion', 'clase_contrato',
        'otra_clase_contrato','pago_anticipado','valor_pago_anticipado'
        ,'ejecucion_fis_contrato','observaciones','just','otra_fuente','otra_fuente_finan'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CONTRATO_SIRECI_SGR'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contrato_sireci_sgr'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
